package otherpackage;

import org.jdom.*;
import org.jdom.input.*;

import java.io.File;
import java.io.FileNotFoundException;

import java.util.*;

public class Demo {	
	int push = 0;
	
	public Demo() {
	}
	
	public static void checkArgs(String[] args) {
	    if (args.length < 1) {
			System.err.println("Usage: Demo <xmlfile>");
			System.exit(0);
		}	
	}
	
	public void inorder(NodeVisitor nv, NodeX cur) {
		NodeIterator iter = cur.nodeIterator();
		boolean wentDown = false;
		String who = cur.debug();
		
		System.out.println("=PUSH=" + who);
		++push;
		
		if (iter.hasDown())
		{
			wentDown = true;
			System.out.println("down from " + who);
			inorder(nv, iter.goDown());
		}
		else
			System.out.println(who + " has no children!");
		
		
		if (wentDown)
		{
			iter.goUp();
		}
		
		System.out.println("=DO=" + who);
		cur.acceptVisitor(nv);
		
		if (iter.hasForward())
		{
			System.out.println("across from " + who);
			inorder(nv, iter.goForward());
		}
		else
		{
			System.out.println(who + " has no younger siblings!");
		}
		
		System.out.println("=POP=" + who);
    }
	
	public void printRes(HashMap map) {
		StringBuffer buf = new StringBuffer("Results\n-------\n");
		
		synchronized(buf)
		{
		    buf.append("Pushes ---> ");
			buf.append(push);
			buf.append("\n");
		}
		
	    Iterator iter = map.entrySet().iterator();
		Map.Entry entry = null;
		
		while(iter.hasNext()) {
		    entry = (Map.Entry)iter.next();
			
			synchronized(buf) {
			    buf.append(entry.getKey());
				buf.append(": ");
				buf.append(entry.getValue());
				buf.append("\n");	
			}
		}
		
		buf.append("=======");
		
		System.out.println(buf.toString());	
	}
	
	public static void main(String[] args) {
		Demo.checkArgs(args);
		
		Document doc = null;
		Demo demo = new Demo();
		
		try	{
            SAXBuilder builder = new SAXBuilder();
		    doc = builder.build(new File( args[0] ));
		}
		catch(JDOMException jde) {
		    System.err.println("Document build failed -- " + jde.getMessage());
			System.exit(0);	
		}
		
		NamespaceCountVisitor nsv = new NamespaceCountVisitor();
		
		demo.inorder(nsv, doc);
		demo.printRes(nsv.mapNamespaces);
		
		System.exit(0);
    }
}