package otherpackage;

import org.jdom.*;

import java.util.HashMap;
import java.util.List;
import java.util.ListIterator;

public class NamespaceCountVisitor implements NodeVisitor
{
	public HashMap mapNamespaces;
	
    public NamespaceCountVisitor() {
		mapNamespaces = new HashMap();
    }
	
	public Object parseNamespace(String ns) {
		int count = 0;
		
		if (mapNamespaces.containsKey(ns))
			count = ((Integer)mapNamespaces.get(ns)).intValue();
			
		Integer I = new Integer(++count);
		mapNamespaces.put(ns, I);
	
		return I;
	}
	
	public Object visitAttribute(Attribute attribute) {
		return parseNamespace(attribute.getNamespacePrefix());
	}
	
	public Object visitCDATA(CDATA cdata) {
		return null;
	}
	
	public Object visitComment(Comment comment) {
		return null;
	}
	
	public Object visitDocument(Document document) {
		return null;
	}
	
	public Object visitElement(Element element) {
		List attrs = element.getAttributes();
		ListIterator liter = attrs.listIterator();
		
		while (liter.hasNext())
		{
			((Attribute)liter.next()).acceptVisitor(this);
		}
		
		return parseNamespace(element.getNamespacePrefix());
	}
	
	public Object visitEntity(Entity entity) {
		return null;
	}
	
	public Object visitProcessingInstruction(ProcessingInstruction pi) {
		return null;
	}
	
	public Object visitText(Text text) {
		return null;
	}
}